]> Pileus Git - ~andy/git/blob - git-submodule.sh
fetch --prune: always print header url
[~andy/git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodule.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9    or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10    or: $dashless [--quiet] init [--] [<path>...]
11    or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12    or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
13    or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14    or: $dashless [--quiet] foreach [--recursive] <command>
15    or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16 OPTIONS_SPEC=
17 SUBDIRECTORY_OK=Yes
18 . git-sh-setup
19 . git-sh-i18n
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
24
25 command=
26 branch=
27 force=
28 reference=
29 cached=
30 recursive=
31 init=
32 files=
33 remote=
34 nofetch=
35 update=
36 prefix=
37 custom_name=
38 depth=
39
40 # The function takes at most 2 arguments. The first argument is the
41 # URL that navigates to the submodule origin repo. When relative, this URL
42 # is relative to the superproject origin URL repo. The second up_path
43 # argument, if specified, is the relative path that navigates
44 # from the submodule working tree to the superproject working tree.
45 #
46 # The output of the function is the origin URL of the submodule.
47 #
48 # The output will either be an absolute URL or filesystem path (if the
49 # superproject origin URL is an absolute URL or filesystem path,
50 # respectively) or a relative file system path (if the superproject
51 # origin URL is a relative file system path).
52 #
53 # When the output is a relative file system path, the path is either
54 # relative to the submodule working tree, if up_path is specified, or to
55 # the superproject working tree otherwise.
56 resolve_relative_url ()
57 {
58         remote=$(get_default_remote)
59         remoteurl=$(git config "remote.$remote.url") ||
60                 remoteurl=$(pwd) # the repository is its own authoritative upstream
61         url="$1"
62         remoteurl=${remoteurl%/}
63         sep=/
64         up_path="$2"
65
66         case "$remoteurl" in
67         *:*|/*)
68                 is_relative=
69                 ;;
70         ./*|../*)
71                 is_relative=t
72                 ;;
73         *)
74                 is_relative=t
75                 remoteurl="./$remoteurl"
76                 ;;
77         esac
78
79         while test -n "$url"
80         do
81                 case "$url" in
82                 ../*)
83                         url="${url#../}"
84                         case "$remoteurl" in
85                         */*)
86                                 remoteurl="${remoteurl%/*}"
87                                 ;;
88                         *:*)
89                                 remoteurl="${remoteurl%:*}"
90                                 sep=:
91                                 ;;
92                         *)
93                                 if test -z "$is_relative" || test "." = "$remoteurl"
94                                 then
95                                         die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
96                                 else
97                                         remoteurl=.
98                                 fi
99                                 ;;
100                         esac
101                         ;;
102                 ./*)
103                         url="${url#./}"
104                         ;;
105                 *)
106                         break;;
107                 esac
108         done
109         remoteurl="$remoteurl$sep${url%/}"
110         echo "${is_relative:+${up_path}}${remoteurl#./}"
111 }
112
113 # Resolve a path to be relative to another path.  This is intended for
114 # converting submodule paths when git-submodule is run in a subdirectory
115 # and only handles paths where the directory separator is '/'.
116 #
117 # The output is the first argument as a path relative to the second argument,
118 # which defaults to $wt_prefix if it is omitted.
119 relative_path ()
120 {
121         local target curdir result
122         target=$1
123         curdir=${2-$wt_prefix}
124         curdir=${curdir%/}
125         result=
126
127         while test -n "$curdir"
128         do
129                 case "$target" in
130                 "$curdir/"*)
131                         target=${target#"$curdir"/}
132                         break
133                         ;;
134                 esac
135
136                 result="${result}../"
137                 if test "$curdir" = "${curdir%/*}"
138                 then
139                         curdir=
140                 else
141                         curdir="${curdir%/*}"
142                 fi
143         done
144
145         echo "$result$target"
146 }
147
148 #
149 # Get submodule info for registered submodules
150 # $@ = path to limit submodule list
151 #
152 module_list()
153 {
154         eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
155         (
156                 git ls-files -z --error-unmatch --stage -- "$@" ||
157                 echo "unmatched pathspec exists"
158         ) |
159         @@PERL@@ -e '
160         my %unmerged = ();
161         my ($null_sha1) = ("0" x 40);
162         my @out = ();
163         my $unmatched = 0;
164         $/ = "\0";
165         while (<STDIN>) {
166                 if (/^unmatched pathspec/) {
167                         $unmatched = 1;
168                         next;
169                 }
170                 chomp;
171                 my ($mode, $sha1, $stage, $path) =
172                         /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173                 next unless $mode eq "160000";
174                 if ($stage ne "0") {
175                         if (!$unmerged{$path}++) {
176                                 push @out, "$mode $null_sha1 U\t$path\n";
177                         }
178                         next;
179                 }
180                 push @out, "$_\n";
181         }
182         if ($unmatched) {
183                 print "#unmatched\n";
184         } else {
185                 print for (@out);
186         }
187         '
188 }
189
190 die_if_unmatched ()
191 {
192         if test "$1" = "#unmatched"
193         then
194                 exit 1
195         fi
196 }
197
198 #
199 # Print a submodule configuration setting
200 #
201 # $1 = submodule name
202 # $2 = option name
203 # $3 = default value
204 #
205 # Checks in the usual git-config places first (for overrides),
206 # otherwise it falls back on .gitmodules.  This allows you to
207 # distribute project-wide defaults in .gitmodules, while still
208 # customizing individual repositories if necessary.  If the option is
209 # not in .gitmodules either, print a default value.
210 #
211 get_submodule_config () {
212         name="$1"
213         option="$2"
214         default="$3"
215         value=$(git config submodule."$name"."$option")
216         if test -z "$value"
217         then
218                 value=$(git config -f .gitmodules submodule."$name"."$option")
219         fi
220         printf '%s' "${value:-$default}"
221 }
222
223
224 #
225 # Map submodule path to submodule name
226 #
227 # $1 = path
228 #
229 module_name()
230 {
231         # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
232         sm_path="$1"
233         re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
234         name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
235                 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
236         test -z "$name" &&
237         die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
238         echo "$name"
239 }
240
241 #
242 # Clone a submodule
243 #
244 # Prior to calling, cmd_update checks that a possibly existing
245 # path is not a git repository.
246 # Likewise, cmd_add checks that path does not exist at all,
247 # since it is the location of a new submodule.
248 #
249 module_clone()
250 {
251         sm_path=$1
252         name=$2
253         url=$3
254         reference="$4"
255         depth="$5"
256         quiet=
257         if test -n "$GIT_QUIET"
258         then
259                 quiet=-q
260         fi
261
262         gitdir=
263         gitdir_base=
264         base_name=$(dirname "$name")
265
266         gitdir=$(git rev-parse --git-dir)
267         gitdir_base="$gitdir/modules/$base_name"
268         gitdir="$gitdir/modules/$name"
269
270         if test -d "$gitdir"
271         then
272                 mkdir -p "$sm_path"
273                 rm -f "$gitdir/index"
274         else
275                 mkdir -p "$gitdir_base"
276                 (
277                         clear_local_git_env
278                         git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
279                                 --separate-git-dir "$gitdir" "$url" "$sm_path"
280                 ) ||
281                 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
282         fi
283
284         # We already are at the root of the work tree but cd_to_toplevel will
285         # resolve any symlinks that might be present in $PWD
286         a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
287         b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
288         # normalize Windows-style absolute paths to POSIX-style absolute paths
289         case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
290         case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
291         # Remove all common leading directories after a sanity check
292         if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
293                 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
294         fi
295         while test "${a%%/*}" = "${b%%/*}"
296         do
297                 a=${a#*/}
298                 b=${b#*/}
299         done
300         # Now chop off the trailing '/'s that were added in the beginning
301         a=${a%/}
302         b=${b%/}
303
304         # Turn each leading "*/" component into "../"
305         rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
306         echo "gitdir: $rel/$a" >"$sm_path/.git"
307
308         rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
309         (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
310 }
311
312 isnumber()
313 {
314         n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
315 }
316
317 #
318 # Add a new submodule to the working tree, .gitmodules and the index
319 #
320 # $@ = repo path
321 #
322 # optional branch is stored in global branch variable
323 #
324 cmd_add()
325 {
326         # parse $args after "submodule ... add".
327         reference_path=
328         while test $# -ne 0
329         do
330                 case "$1" in
331                 -b | --branch)
332                         case "$2" in '') usage ;; esac
333                         branch=$2
334                         shift
335                         ;;
336                 -f | --force)
337                         force=$1
338                         ;;
339                 -q|--quiet)
340                         GIT_QUIET=1
341                         ;;
342                 --reference)
343                         case "$2" in '') usage ;; esac
344                         reference_path=$2
345                         shift
346                         ;;
347                 --reference=*)
348                         reference_path="${1#--reference=}"
349                         ;;
350                 --name)
351                         case "$2" in '') usage ;; esac
352                         custom_name=$2
353                         shift
354                         ;;
355                 --depth)
356                         case "$2" in '') usage ;; esac
357                         depth="--depth=$2"
358                         shift
359                         ;;
360                 --depth=*)
361                         depth=$1
362                         ;;
363                 --)
364                         shift
365                         break
366                         ;;
367                 -*)
368                         usage
369                         ;;
370                 *)
371                         break
372                         ;;
373                 esac
374                 shift
375         done
376
377         if test -n "$reference_path"
378         then
379                 is_absolute_path "$reference_path" ||
380                 reference_path="$wt_prefix$reference_path"
381
382                 reference="--reference=$reference_path"
383         fi
384
385         repo=$1
386         sm_path=$2
387
388         if test -z "$sm_path"; then
389                 sm_path=$(echo "$repo" |
390                         sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
391         fi
392
393         if test -z "$repo" -o -z "$sm_path"; then
394                 usage
395         fi
396
397         is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
398
399         # assure repo is absolute or relative to parent
400         case "$repo" in
401         ./*|../*)
402                 test -z "$wt_prefix" ||
403                 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
404
405                 # dereference source url relative to parent's url
406                 realrepo=$(resolve_relative_url "$repo") || exit
407                 ;;
408         *:*|/*)
409                 # absolute url
410                 realrepo=$repo
411                 ;;
412         *)
413                 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
414         ;;
415         esac
416
417         # normalize path:
418         # multiple //; leading ./; /./; /../; trailing /
419         sm_path=$(printf '%s/\n' "$sm_path" |
420                 sed -e '
421                         s|//*|/|g
422                         s|^\(\./\)*||
423                         s|/\./|/|g
424                         :start
425                         s|\([^/]*\)/\.\./||
426                         tstart
427                         s|/*$||
428                 ')
429         git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
430         die "$(eval_gettext "'\$sm_path' already exists in the index")"
431
432         if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
433         then
434                 eval_gettextln "The following path is ignored by one of your .gitignore files:
435 \$sm_path
436 Use -f if you really want to add it." >&2
437                 exit 1
438         fi
439
440         if test -n "$custom_name"
441         then
442                 sm_name="$custom_name"
443         else
444                 sm_name="$sm_path"
445         fi
446
447         # perhaps the path exists and is already a git repo, else clone it
448         if test -e "$sm_path"
449         then
450                 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
451                 then
452                         eval_gettextln "Adding existing repo at '\$sm_path' to the index"
453                 else
454                         die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
455                 fi
456
457         else
458                 if test -d ".git/modules/$sm_name"
459                 then
460                         if test -z "$force"
461                         then
462                                 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
463                                 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
464                                 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
465                                 echo >&2 "  $realrepo"
466                                 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
467                                 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
468                         else
469                                 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
470                         fi
471                 fi
472                 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
473                 (
474                         clear_local_git_env
475                         cd "$sm_path" &&
476                         # ash fails to wordsplit ${branch:+-b "$branch"...}
477                         case "$branch" in
478                         '') git checkout -f -q ;;
479                         ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
480                         esac
481                 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
482         fi
483         git config submodule."$sm_name".url "$realrepo"
484
485         git add $force "$sm_path" ||
486         die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
487
488         git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
489         git config -f .gitmodules submodule."$sm_name".url "$repo" &&
490         if test -n "$branch"
491         then
492                 git config -f .gitmodules submodule."$sm_name".branch "$branch"
493         fi &&
494         git add --force .gitmodules ||
495         die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
496 }
497
498 #
499 # Execute an arbitrary command sequence in each checked out
500 # submodule
501 #
502 # $@ = command to execute
503 #
504 cmd_foreach()
505 {
506         # parse $args after "submodule ... foreach".
507         while test $# -ne 0
508         do
509                 case "$1" in
510                 -q|--quiet)
511                         GIT_QUIET=1
512                         ;;
513                 --recursive)
514                         recursive=1
515                         ;;
516                 -*)
517                         usage
518                         ;;
519                 *)
520                         break
521                         ;;
522                 esac
523                 shift
524         done
525
526         toplevel=$(pwd)
527
528         # dup stdin so that it can be restored when running the external
529         # command in the subshell (and a recursive call to this function)
530         exec 3<&0
531
532         module_list |
533         while read mode sha1 stage sm_path
534         do
535                 die_if_unmatched "$mode"
536                 if test -e "$sm_path"/.git
537                 then
538                         displaypath=$(relative_path "$sm_path")
539                         say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
540                         name=$(module_name "$sm_path")
541                         (
542                                 prefix="$prefix$sm_path/"
543                                 clear_local_git_env
544                                 cd "$sm_path" &&
545                                 sm_path=$(relative_path "$sm_path") &&
546                                 # we make $path available to scripts ...
547                                 path=$sm_path &&
548                                 if test $# -eq 1
549                                 then
550                                         eval "$1"
551                                 else
552                                         "$@"
553                                 fi &&
554                                 if test -n "$recursive"
555                                 then
556                                         cmd_foreach "--recursive" "$@"
557                                 fi
558                         ) <&3 3<&- ||
559                         die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
560                 fi
561         done
562 }
563
564 #
565 # Register submodules in .git/config
566 #
567 # $@ = requested paths (default to all)
568 #
569 cmd_init()
570 {
571         # parse $args after "submodule ... init".
572         while test $# -ne 0
573         do
574                 case "$1" in
575                 -q|--quiet)
576                         GIT_QUIET=1
577                         ;;
578                 --)
579                         shift
580                         break
581                         ;;
582                 -*)
583                         usage
584                         ;;
585                 *)
586                         break
587                         ;;
588                 esac
589                 shift
590         done
591
592         module_list "$@" |
593         while read mode sha1 stage sm_path
594         do
595                 die_if_unmatched "$mode"
596                 name=$(module_name "$sm_path") || exit
597
598                 displaypath=$(relative_path "$sm_path")
599
600                 # Copy url setting when it is not set yet
601                 if test -z "$(git config "submodule.$name.url")"
602                 then
603                         url=$(git config -f .gitmodules submodule."$name".url)
604                         test -z "$url" &&
605                         die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
606
607                         # Possibly a url relative to parent
608                         case "$url" in
609                         ./*|../*)
610                                 url=$(resolve_relative_url "$url") || exit
611                                 ;;
612                         esac
613                         git config submodule."$name".url "$url" ||
614                         die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
615
616                         say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
617                 fi
618
619                 # Copy "update" setting when it is not set yet
620                 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
621                    test -n "$upd" &&
622                    test -z "$(git config submodule."$name".update)"
623                 then
624                         case "$upd" in
625                         rebase | merge | none)
626                                 ;; # known modes of updating
627                         *)
628                                 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
629                                 upd=none
630                                 ;;
631                         esac
632                         git config submodule."$name".update "$upd" ||
633                         die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
634                 fi
635         done
636 }
637
638 #
639 # Unregister submodules from .git/config and remove their work tree
640 #
641 # $@ = requested paths (use '.' to deinit all submodules)
642 #
643 cmd_deinit()
644 {
645         # parse $args after "submodule ... deinit".
646         while test $# -ne 0
647         do
648                 case "$1" in
649                 -f|--force)
650                         force=$1
651                         ;;
652                 -q|--quiet)
653                         GIT_QUIET=1
654                         ;;
655                 --)
656                         shift
657                         break
658                         ;;
659                 -*)
660                         usage
661                         ;;
662                 *)
663                         break
664                         ;;
665                 esac
666                 shift
667         done
668
669         if test $# = 0
670         then
671                 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
672         fi
673
674         module_list "$@" |
675         while read mode sha1 stage sm_path
676         do
677                 die_if_unmatched "$mode"
678                 name=$(module_name "$sm_path") || exit
679
680                 displaypath=$(relative_path "$sm_path")
681
682                 # Remove the submodule work tree (unless the user already did it)
683                 if test -d "$sm_path"
684                 then
685                         # Protect submodules containing a .git directory
686                         if test -d "$sm_path/.git"
687                         then
688                                 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
689                                 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
690                         fi
691
692                         if test -z "$force"
693                         then
694                                 git rm -qn "$sm_path" ||
695                                 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
696                         fi
697                         rm -rf "$sm_path" &&
698                         say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
699                         say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
700                 fi
701
702                 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
703
704                 # Remove the .git/config entries (unless the user already did it)
705                 if test -n "$(git config --get-regexp submodule."$name\.")"
706                 then
707                         # Remove the whole section so we have a clean state when
708                         # the user later decides to init this submodule again
709                         url=$(git config submodule."$name".url)
710                         git config --remove-section submodule."$name" 2>/dev/null &&
711                         say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
712                 fi
713         done
714 }
715
716 #
717 # Update each submodule path to correct revision, using clone and checkout as needed
718 #
719 # $@ = requested paths (default to all)
720 #
721 cmd_update()
722 {
723         # parse $args after "submodule ... update".
724         while test $# -ne 0
725         do
726                 case "$1" in
727                 -q|--quiet)
728                         GIT_QUIET=1
729                         ;;
730                 -i|--init)
731                         init=1
732                         ;;
733                 --remote)
734                         remote=1
735                         ;;
736                 -N|--no-fetch)
737                         nofetch=1
738                         ;;
739                 -f|--force)
740                         force=$1
741                         ;;
742                 -r|--rebase)
743                         update="rebase"
744                         ;;
745                 --reference)
746                         case "$2" in '') usage ;; esac
747                         reference="--reference=$2"
748                         shift
749                         ;;
750                 --reference=*)
751                         reference="$1"
752                         ;;
753                 -m|--merge)
754                         update="merge"
755                         ;;
756                 --recursive)
757                         recursive=1
758                         ;;
759                 --checkout)
760                         update="checkout"
761                         ;;
762                 --depth)
763                         case "$2" in '') usage ;; esac
764                         depth="--depth=$2"
765                         shift
766                         ;;
767                 --depth=*)
768                         depth=$1
769                         ;;
770                 --)
771                         shift
772                         break
773                         ;;
774                 -*)
775                         usage
776                         ;;
777                 *)
778                         break
779                         ;;
780                 esac
781                 shift
782         done
783
784         if test -n "$init"
785         then
786                 cmd_init "--" "$@" || return
787         fi
788
789         cloned_modules=
790         module_list "$@" | {
791         err=
792         while read mode sha1 stage sm_path
793         do
794                 die_if_unmatched "$mode"
795                 if test "$stage" = U
796                 then
797                         echo >&2 "Skipping unmerged submodule $prefix$sm_path"
798                         continue
799                 fi
800                 name=$(module_name "$sm_path") || exit
801                 url=$(git config submodule."$name".url)
802                 branch=$(get_submodule_config "$name" branch master)
803                 if ! test -z "$update"
804                 then
805                         update_module=$update
806                 else
807                         update_module=$(git config submodule."$name".update)
808                 fi
809
810                 displaypath=$(relative_path "$prefix$sm_path")
811
812                 if test "$update_module" = "none"
813                 then
814                         echo "Skipping submodule '$displaypath'"
815                         continue
816                 fi
817
818                 if test -z "$url"
819                 then
820                         # Only mention uninitialized submodules when its
821                         # path have been specified
822                         test "$#" != "0" &&
823                         say "$(eval_gettext "Submodule path '\$displaypath' not initialized
824 Maybe you want to use 'update --init'?")"
825                         continue
826                 fi
827
828                 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
829                 then
830                         module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
831                         cloned_modules="$cloned_modules;$name"
832                         subsha1=
833                 else
834                         subsha1=$(clear_local_git_env; cd "$sm_path" &&
835                                 git rev-parse --verify HEAD) ||
836                         die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
837                 fi
838
839                 if test -n "$remote"
840                 then
841                         if test -z "$nofetch"
842                         then
843                                 # Fetch remote before determining tracking $sha1
844                                 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
845                                 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
846                         fi
847                         remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
848                         sha1=$(clear_local_git_env; cd "$sm_path" &&
849                                 git rev-parse --verify "${remote_name}/${branch}") ||
850                         die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
851                 fi
852
853                 if test "$subsha1" != "$sha1" -o -n "$force"
854                 then
855                         subforce=$force
856                         # If we don't already have a -f flag and the submodule has never been checked out
857                         if test -z "$subsha1" -a -z "$force"
858                         then
859                                 subforce="-f"
860                         fi
861
862                         if test -z "$nofetch"
863                         then
864                                 # Run fetch only if $sha1 isn't present or it
865                                 # is not reachable from a ref.
866                                 (clear_local_git_env; cd "$sm_path" &&
867                                         ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
868                                          test -z "$rev") || git-fetch)) ||
869                                 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
870                         fi
871
872                         # Is this something we just cloned?
873                         case ";$cloned_modules;" in
874                         *";$name;"*)
875                                 # then there is no local change to integrate
876                                 update_module= ;;
877                         esac
878
879                         must_die_on_failure=
880                         case "$update_module" in
881                         rebase)
882                                 command="git rebase"
883                                 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
884                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
885                                 must_die_on_failure=yes
886                                 ;;
887                         merge)
888                                 command="git merge"
889                                 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
890                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
891                                 must_die_on_failure=yes
892                                 ;;
893                         !*)
894                                 command="${update_module#!}"
895                                 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule  path '\$prefix\$sm_path'")"
896                                 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
897                                 must_die_on_failure=yes
898                                 ;;
899                         *)
900                                 command="git checkout $subforce -q"
901                                 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
902                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
903                                 ;;
904                         esac
905
906                         if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
907                         then
908                                 say "$say_msg"
909                         elif test -n "$must_die_on_failure"
910                         then
911                                 die_with_status 2 "$die_msg"
912                         else
913                                 err="${err};$die_msg"
914                                 continue
915                         fi
916                 fi
917
918                 if test -n "$recursive"
919                 then
920                         (
921                                 prefix="$prefix$sm_path/"
922                                 clear_local_git_env
923                                 cd "$sm_path" &&
924                                 eval cmd_update
925                         )
926                         res=$?
927                         if test $res -gt 0
928                         then
929                                 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
930                                 if test $res -eq 1
931                                 then
932                                         err="${err};$die_msg"
933                                         continue
934                                 else
935                                         die_with_status $res "$die_msg"
936                                 fi
937                         fi
938                 fi
939         done
940
941         if test -n "$err"
942         then
943                 OIFS=$IFS
944                 IFS=';'
945                 for e in $err
946                 do
947                         if test -n "$e"
948                         then
949                                 echo >&2 "$e"
950                         fi
951                 done
952                 IFS=$OIFS
953                 exit 1
954         fi
955         }
956 }
957
958 set_name_rev () {
959         revname=$( (
960                 clear_local_git_env
961                 cd "$1" && {
962                         git describe "$2" 2>/dev/null ||
963                         git describe --tags "$2" 2>/dev/null ||
964                         git describe --contains "$2" 2>/dev/null ||
965                         git describe --all --always "$2"
966                 }
967         ) )
968         test -z "$revname" || revname=" ($revname)"
969 }
970 #
971 # Show commit summary for submodules in index or working tree
972 #
973 # If '--cached' is given, show summary between index and given commit,
974 # or between working tree and given commit
975 #
976 # $@ = [commit (default 'HEAD'),] requested paths (default all)
977 #
978 cmd_summary() {
979         summary_limit=-1
980         for_status=
981         diff_cmd=diff-index
982
983         # parse $args after "submodule ... summary".
984         while test $# -ne 0
985         do
986                 case "$1" in
987                 --cached)
988                         cached="$1"
989                         ;;
990                 --files)
991                         files="$1"
992                         ;;
993                 --for-status)
994                         for_status="$1"
995                         ;;
996                 -n|--summary-limit)
997                         summary_limit="$2"
998                         isnumber "$summary_limit" || usage
999                         shift
1000                         ;;
1001                 --summary-limit=*)
1002                         summary_limit="${1#--summary-limit=}"
1003                         isnumber "$summary_limit" || usage
1004                         ;;
1005                 --)
1006                         shift
1007                         break
1008                         ;;
1009                 -*)
1010                         usage
1011                         ;;
1012                 *)
1013                         break
1014                         ;;
1015                 esac
1016                 shift
1017         done
1018
1019         test $summary_limit = 0 && return
1020
1021         if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
1022         then
1023                 head=$rev
1024                 test $# = 0 || shift
1025         elif test -z "$1" -o "$1" = "HEAD"
1026         then
1027                 # before the first commit: compare with an empty tree
1028                 head=$(git hash-object -w -t tree --stdin </dev/null)
1029                 test -z "$1" || shift
1030         else
1031                 head="HEAD"
1032         fi
1033
1034         if [ -n "$files" ]
1035         then
1036                 test -n "$cached" &&
1037                 die "$(gettext "The --cached option cannot be used with the --files option")"
1038                 diff_cmd=diff-files
1039                 head=
1040         fi
1041
1042         cd_to_toplevel
1043         eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
1044         # Get modified modules cared by user
1045         modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
1046                 sane_egrep '^:([0-7]* )?160000' |
1047                 while read mod_src mod_dst sha1_src sha1_dst status sm_path
1048                 do
1049                         # Always show modules deleted or type-changed (blob<->module)
1050                         test $status = D -o $status = T && echo "$sm_path" && continue
1051                         # Respect the ignore setting for --for-status.
1052                         if test -n "$for_status"
1053                         then
1054                                 name=$(module_name "$sm_path")
1055                                 ignore_config=$(get_submodule_config "$name" ignore none)
1056                                 test $status != A -a $ignore_config = all && continue
1057                         fi
1058                         # Also show added or modified modules which are checked out
1059                         GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1060                         echo "$sm_path"
1061                 done
1062         )
1063
1064         test -z "$modules" && return
1065
1066         git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
1067         sane_egrep '^:([0-7]* )?160000' |
1068         cut -c2- |
1069         while read mod_src mod_dst sha1_src sha1_dst status name
1070         do
1071                 if test -z "$cached" &&
1072                         test $sha1_dst = 0000000000000000000000000000000000000000
1073                 then
1074                         case "$mod_dst" in
1075                         160000)
1076                                 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1077                                 ;;
1078                         100644 | 100755 | 120000)
1079                                 sha1_dst=$(git hash-object $name)
1080                                 ;;
1081                         000000)
1082                                 ;; # removed
1083                         *)
1084                                 # unexpected type
1085                                 eval_gettextln "unexpected mode \$mod_dst" >&2
1086                                 continue ;;
1087                         esac
1088                 fi
1089                 missing_src=
1090                 missing_dst=
1091
1092                 test $mod_src = 160000 &&
1093                 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1094                 missing_src=t
1095
1096                 test $mod_dst = 160000 &&
1097                 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1098                 missing_dst=t
1099
1100                 display_name=$(relative_path "$name")
1101
1102                 total_commits=
1103                 case "$missing_src,$missing_dst" in
1104                 t,)
1105                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
1106                         ;;
1107                 ,t)
1108                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
1109                         ;;
1110                 t,t)
1111                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1112                         ;;
1113                 *)
1114                         errmsg=
1115                         total_commits=$(
1116                         if test $mod_src = 160000 -a $mod_dst = 160000
1117                         then
1118                                 range="$sha1_src...$sha1_dst"
1119                         elif test $mod_src = 160000
1120                         then
1121                                 range=$sha1_src
1122                         else
1123                                 range=$sha1_dst
1124                         fi
1125                         GIT_DIR="$name/.git" \
1126                         git rev-list --first-parent $range -- | wc -l
1127                         )
1128                         total_commits=" ($(($total_commits + 0)))"
1129                         ;;
1130                 esac
1131
1132                 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1133                 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1134                 if test $status = T
1135                 then
1136                         blob="$(gettext "blob")"
1137                         submodule="$(gettext "submodule")"
1138                         if test $mod_dst = 160000
1139                         then
1140                                 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1141                         else
1142                                 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1143                         fi
1144                 else
1145                         echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1146                 fi
1147                 if test -n "$errmsg"
1148                 then
1149                         # Don't give error msg for modification whose dst is not submodule
1150                         # i.e. deleted or changed to blob
1151                         test $mod_dst = 160000 && echo "$errmsg"
1152                 else
1153                         if test $mod_src = 160000 -a $mod_dst = 160000
1154                         then
1155                                 limit=
1156                                 test $summary_limit -gt 0 && limit="-$summary_limit"
1157                                 GIT_DIR="$name/.git" \
1158                                 git log $limit --pretty='format:  %m %s' \
1159                                 --first-parent $sha1_src...$sha1_dst
1160                         elif test $mod_dst = 160000
1161                         then
1162                                 GIT_DIR="$name/.git" \
1163                                 git log --pretty='format:  > %s' -1 $sha1_dst
1164                         else
1165                                 GIT_DIR="$name/.git" \
1166                                 git log --pretty='format:  < %s' -1 $sha1_src
1167                         fi
1168                         echo
1169                 fi
1170                 echo
1171         done
1172 }
1173 #
1174 # List all submodules, prefixed with:
1175 #  - submodule not initialized
1176 #  + different revision checked out
1177 #
1178 # If --cached was specified the revision in the index will be printed
1179 # instead of the currently checked out revision.
1180 #
1181 # $@ = requested paths (default to all)
1182 #
1183 cmd_status()
1184 {
1185         # parse $args after "submodule ... status".
1186         while test $# -ne 0
1187         do
1188                 case "$1" in
1189                 -q|--quiet)
1190                         GIT_QUIET=1
1191                         ;;
1192                 --cached)
1193                         cached=1
1194                         ;;
1195                 --recursive)
1196                         recursive=1
1197                         ;;
1198                 --)
1199                         shift
1200                         break
1201                         ;;
1202                 -*)
1203                         usage
1204                         ;;
1205                 *)
1206                         break
1207                         ;;
1208                 esac
1209                 shift
1210         done
1211
1212         module_list "$@" |
1213         while read mode sha1 stage sm_path
1214         do
1215                 die_if_unmatched "$mode"
1216                 name=$(module_name "$sm_path") || exit
1217                 url=$(git config submodule."$name".url)
1218                 displaypath=$(relative_path "$prefix$sm_path")
1219                 if test "$stage" = U
1220                 then
1221                         say "U$sha1 $displaypath"
1222                         continue
1223                 fi
1224                 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
1225                 then
1226                         say "-$sha1 $displaypath"
1227                         continue;
1228                 fi
1229                 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1230                 then
1231                         set_name_rev "$sm_path" "$sha1"
1232                         say " $sha1 $displaypath$revname"
1233                 else
1234                         if test -z "$cached"
1235                         then
1236                                 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1237                         fi
1238                         set_name_rev "$sm_path" "$sha1"
1239                         say "+$sha1 $displaypath$revname"
1240                 fi
1241
1242                 if test -n "$recursive"
1243                 then
1244                         (
1245                                 prefix="$displaypath/"
1246                                 clear_local_git_env
1247                                 cd "$sm_path" &&
1248                                 eval cmd_status
1249                         ) ||
1250                         die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1251                 fi
1252         done
1253 }
1254 #
1255 # Sync remote urls for submodules
1256 # This makes the value for remote.$remote.url match the value
1257 # specified in .gitmodules.
1258 #
1259 cmd_sync()
1260 {
1261         while test $# -ne 0
1262         do
1263                 case "$1" in
1264                 -q|--quiet)
1265                         GIT_QUIET=1
1266                         shift
1267                         ;;
1268                 --recursive)
1269                         recursive=1
1270                         shift
1271                         ;;
1272                 --)
1273                         shift
1274                         break
1275                         ;;
1276                 -*)
1277                         usage
1278                         ;;
1279                 *)
1280                         break
1281                         ;;
1282                 esac
1283         done
1284         cd_to_toplevel
1285         module_list "$@" |
1286         while read mode sha1 stage sm_path
1287         do
1288                 die_if_unmatched "$mode"
1289                 name=$(module_name "$sm_path")
1290                 url=$(git config -f .gitmodules --get submodule."$name".url)
1291
1292                 # Possibly a url relative to parent
1293                 case "$url" in
1294                 ./*|../*)
1295                         # rewrite foo/bar as ../.. to find path from
1296                         # submodule work tree to superproject work tree
1297                         up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1298                         # guarantee a trailing /
1299                         up_path=${up_path%/}/ &&
1300                         # path from submodule work tree to submodule origin repo
1301                         sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1302                         # path from superproject work tree to submodule origin repo
1303                         super_config_url=$(resolve_relative_url "$url") || exit
1304                         ;;
1305                 *)
1306                         sub_origin_url="$url"
1307                         super_config_url="$url"
1308                         ;;
1309                 esac
1310
1311                 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1312                 then
1313                         displaypath=$(relative_path "$prefix$sm_path")
1314                         say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1315                         git config submodule."$name".url "$super_config_url"
1316
1317                         if test -e "$sm_path"/.git
1318                         then
1319                         (
1320                                 clear_local_git_env
1321                                 cd "$sm_path"
1322                                 remote=$(get_default_remote)
1323                                 git config remote."$remote".url "$sub_origin_url"
1324
1325                                 if test -n "$recursive"
1326                                 then
1327                                         prefix="$prefix$sm_path/"
1328                                         eval cmd_sync
1329                                 fi
1330                         )
1331                         fi
1332                 fi
1333         done
1334 }
1335
1336 # This loop parses the command line arguments to find the
1337 # subcommand name to dispatch.  Parsing of the subcommand specific
1338 # options are primarily done by the subcommand implementations.
1339 # Subcommand specific options such as --branch and --cached are
1340 # parsed here as well, for backward compatibility.
1341
1342 while test $# != 0 && test -z "$command"
1343 do
1344         case "$1" in
1345         add | foreach | init | deinit | update | status | summary | sync)
1346                 command=$1
1347                 ;;
1348         -q|--quiet)
1349                 GIT_QUIET=1
1350                 ;;
1351         -b|--branch)
1352                 case "$2" in
1353                 '')
1354                         usage
1355                         ;;
1356                 esac
1357                 branch="$2"; shift
1358                 ;;
1359         --cached)
1360                 cached="$1"
1361                 ;;
1362         --)
1363                 break
1364                 ;;
1365         -*)
1366                 usage
1367                 ;;
1368         *)
1369                 break
1370                 ;;
1371         esac
1372         shift
1373 done
1374
1375 # No command word defaults to "status"
1376 if test -z "$command"
1377 then
1378     if test $# = 0
1379     then
1380         command=status
1381     else
1382         usage
1383     fi
1384 fi
1385
1386 # "-b branch" is accepted only by "add"
1387 if test -n "$branch" && test "$command" != add
1388 then
1389         usage
1390 fi
1391
1392 # "--cached" is accepted only by "status" and "summary"
1393 if test -n "$cached" && test "$command" != status -a "$command" != summary
1394 then
1395         usage
1396 fi
1397
1398 "cmd_$command" "$@"